<?php

// Id used to identify this page within functions.
$PageID = "RETURN";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "language.inc";
require_once "search.inc";
require_once "MARC.inc";
require_once "mgmnt.inc";

$onLoad = "if(document.book_return) document.book_return.book_id.select(); if(document.return_receipt) document.return_receipt.submit();";

layout_header(array('onload' => $onLoad));

if(isset($_REQUEST['stage']) && $_REQUEST['stage'] == 2 && isset($_REQUEST['book_id']) && $_REQUEST['book_id'] == "")
{
	if(isset($_REQUEST['old_ids']) && $_REQUEST['old_ids'] != "")
	{
		$books = split(",", $_REQUEST['old_ids']);

		foreach ($books as $id)
		{
			$res = mysql_query("SELECT * FROM reservations WHERE reserve_book_id=".$id);
			$reserved = mysql_fetch_array($res);
			if(mysql_num_rows($res))
			{
				inform_reservant($id, $reserved['reserve_user_id']);
			}

			$success = 1;
			mysql_query("DELETE FROM borrowed WHERE borrowed_book_id=".$id);
			if(!mysql_affected_rows())
				$success = 0;

			mysql_query("UPDATE books SET book_borrowed=0 where book_id=".$id);
			if(!mysql_affected_rows())
				$success = 0;
		}
		if($success)
		{
			$message = $langText['RETURN_SUCCESS'];
			$status = 'ok';

			if (check_priv('RECEIPT_PRINTER'))
			{
				list ($header, $footer) = receipt_text('return', $config['language']); //change to returners language?
				?>

					<form name="return_receipt" method="get" action="print.php">
						<input type="hidden" name="id" value="<?php echo $_REQUEST['id'] ?>" />
						<input type="hidden" name="auth" value="<?php echo $_REQUEST['auth'] ?>" />
						<input type="hidden" name="type" value="receipt" />
						<input type="hidden" name="template" value="return" />
						<input type="hidden" name="old_ids" value="<?php echo $_REQUEST['old_ids'] ?>" />
						<input type="hidden" name="language" value="<?php echo $config['language'] ?>" />
						<input type="hidden" name="header" value="<?php echo $header ?>" />
						<input type="hidden" name="footer" value="<?php echo $footer ?>" />
					</form>

				<?php
			}
		}
		else
		{
			$message = $langText['ERROR_RETURN'];
			$status = 'error';
		}

		unset($_REQUEST['old_ids']);
	}
	else
	{
		$message = $langText['ERROR_NO_BOOKS_TO_RETURN'];
		$status = 'error';
	}

	layout_page_title($message, $status);
}

layout_page_title();

?>

<form name='book_return' action='return.php' method='get'>
	<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
	<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
	<input type='hidden' name='stage' value='2'>

	<?php echo $langText['ENTER_BOOK_ID']?>:&nbsp;
	<input type='text' name='book_id' size='20'>&nbsp;&nbsp;
	<input type='submit' name='submit' class='button' value='<?php echo $langText['BUTTON_RETURN']?>'>

	<br />
	<br />

<?php

if(isset($_REQUEST['stage']) && $_REQUEST['stage'] == 2 && (!isset($_REQUEST['book_id']) || $_REQUEST['book_id'] != ""))
{
	//put error first
	if ((isset($_REQUEST['book_id']) && !is_book($_REQUEST['book_id'])))
	{
		layout_page_info($langText['ERROR_NOT_BOOK_ID'], 'error', TRUE);
		unset($_REQUEST['book_id']);
	}

	// Chop off the book_id suffix
	if(isset($_REQUEST['book_id']))
		$_REQUEST['book_id'] = chop_last($_REQUEST['book_id']);

	$ids = "";
	$books = array();
	$content = array();
	$book_ids = array();
	$book_ids_only = array();
	$old_rows = array();
	$i = 0;
	$ii = 1;
	$hits_inc = 0;
	$table_header = 0;

	if(isset($_REQUEST['book_id']) || isset($_REQUEST['old_ids']))
	{
		$headers = array($langText['BOOK_ID']);

		foreach ($MARC_display_in_list as $value)
		{
			array_push($headers, $langText[strtoupper($MARC_config[$value])]);
		}
	}

	if(isset($_REQUEST['old_ids']) && $_REQUEST['old_ids'] != "")
	{
		list($book_list, $book_ids_only, $books) = zebra_list_syntax($_REQUEST['old_ids']);

		$_REQUEST['element'] = "F";

		if(count($books) > 1)
			list($YAZ_items, $hits) = search("001", $book_list, "1", count($books), "", "", "@or");
		else
			list($YAZ_items, $hits) = search("001", $book_list, "1");

		if($hits)
		{
			$i = 0;
			while($i < count($YAZ_items))
			{
				parseMARC($YAZ_items[$i]);
				$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
				$rows[book_control_number()] = $row;

				$i++;
			}

			$i = 0;
			while($i < count($books))
			{
				$content = array(format_book_id($books[$i]));
				$row = array();

				$row = $rows[$book_ids_only[$i]];

				if(!$table_header) {
					layout_table_header($headers);
					$table_header = 1;
				}

				while(list($key, $value) = each($row))
				{
					array_push($content, $row[$key]);
				}

				layout_table_row($content);

				$i++;
			}
		}
	}

	if(isset($_REQUEST['book_id']) && $_REQUEST['book_id'] != "" && !in_array($_REQUEST['book_id'], $books))
	{
		$result = mysql_query("SELECT book_control_number, book_borrowed FROM books WHERE book_id=".$_REQUEST['book_id']);
		$sql_row = mysql_fetch_array($result);
		if(mysql_num_rows($result))
		{
			if($sql_row['book_borrowed'])
			{
				$_REQUEST['element'] = "F";
				list($YAZ_items, $hits) = search("001", format_control_number($sql_row['book_control_number']), "1");
				if($hits)
				{
					if(isset($_REQUEST['old_ids']))
						$_REQUEST['old_ids'] = $_REQUEST['old_ids'].",".$_REQUEST['book_id'];
					else
						$_REQUEST['old_ids'] = $_REQUEST['book_id'];

					$content = array(format_book_id($_REQUEST['book_id']));
					$row = array();

					parseMARC($YAZ_items[0]);
					$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
					$old_rows[format_control_number($sql_row['book_control_number'])] = $row;

					if(!$table_header) {
						layout_table_header($headers);
						$table_header = 1;
					}

					while(list($key, $value) = each($row))
					{
						array_push($content, $row[$key]);
					}

					layout_table_row($content);
				}
				else {
					layout_page_info($langText['ERROR_NO_BOOK'], 'error', TRUE);
				}
			}
			else {
				layout_page_info($langText['ERROR_BOOK_NOT_BORROWED'], 'error', TRUE);
			}
		}
		else {
			layout_page_info($langText['ERROR_NO_BOOK'], 'error', TRUE);
		}
	}
	else {
		layout_page_info($langText['ERROR_ALREADY_ENTERED'], 'error', TRUE);
	}

	if(!empty($headers) && $table_header) {
		layout_page_info($langText['BOOK_LIST'], '', TRUE);
		layout_table_footer();
	}
}

if(isset($_REQUEST['old_ids'])) {
	print "<input type='hidden' name='old_ids' value='".$_REQUEST['old_ids']."'>";
}

echo "</form>";

layout_footer();

?>
